-------------------------------------------------------------------------------
-- Externals
-------------------------------------------------------------------------------

local Dewdrop = AceLibrary("Dewdrop-2.0")

-------------------------------------------------------------------------------
-- Addon declaration	
-------------------------------------------------------------------------------

MinimapTarget = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0","AceHook-2.1")
local MinimapTarget = MinimapTarget

MinimapTarget.revision = tonumber(("$Revision: 27 $"):match("%d+"))
MinimapTarget.version = "r" .. MinimapTarget.revision
MinimapTarget.date = string.sub("$Date: 2008-03-26 18:58:28 +0000 (Wed, 26 Mar 2008) $", 8, 17)		


-------------------------------------------------------------------------------
-- Initializing
-------------------------------------------------------------------------------

local OldOnClick
function MinimapTarget:OnEnable(first)
	local Chinchilla_Ping = Chinchilla and Chinchilla:GetModule("Ping")
	if Chinchilla_Ping then
		self:Hook(Chinchilla_Ping, "Minimap_OnClick", true)
		OldOnClick = self.hooks[Chinchilla_Ping].Minimap_OnClick
	else
		self:Hook("Minimap_OnClick", true)
		OldOnClick = self.hooks.Minimap_OnClick
	end
end

-------------------------------------------------------------------------------
-- Locals
-------------------------------------------------------------------------------

local tooltip

-------------------------------------------------------------------------------
-- Core
-------------------------------------------------------------------------------

function MinimapTarget:Minimap_OnClick(...)
	-- if IsShiftKeyDown() and GameTooltip:IsVisible() then
	if arg1 == "RightButton" then -- Don't like using this global
		if GameTooltip:IsVisible() then
			self:TargetClick()
		end
		-- Don't "ping" if no tooltip is shown to prevent mispings
	else
		OldOnClick(...)
	end
end

local function feedDewdrop()
	for line in tooltip:gmatch("[^\n]+") do		
		local name = line
		if line:find("|c") then
			name = line:match("|c%x%x%x%x%x%x%x%x([^|]+)|r")
		end
		Dewdrop:AddLine(
			'text', line,
			'secure', {
				type  = 'macro',
				macrotext = ("/targetexact %s"):format(name)
			},
			'closeWhenClicked', true
		)
	end
	Dewdrop:AddLine(
		'text', 'Cancel',
		'closeWhenClicked', true
	)
end

function MinimapTarget:TargetClick()
	tooltip = GameTooltipTextLeft1:IsVisible() and GameTooltipTextLeft1:GetText()
	if tooltip then
		Dewdrop:Open(
			'MinimapTarget', 
			'children', feedDewdrop,
			'point', 'TOPRIGHT',
			'cursorX', -10,
			'cursorY', 10
		)
	end	
end
